var d = Object.defineProperty;
var m = (o, e, t) => e in o ? d(o, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[e] = t;
var a = (o, e, t) => m(o, typeof e != "symbol" ? e + "" : e, t);
import u from "@harcokuppens/boolean-expression";
import { unMarkText as f, markText as b } from "@harcokuppens/highlight-words";
class y {
  constructor() {
    a(this, "htmlPageSpecificFilterAndMarkCallback", null);
    a(this, "elementsCssSelectorForItems", "li");
    a(this, "elementsCssSelectorForSectionItems", null);
    a(this, "highlightingActive", !0);
    a(this, "caseSensitive", !1);
    a(this, "id", "BooleanSearch");
  }
  /**
   * Sets the auto-generated search form in the HTML element with the specified ID.
   * @returns {this} The current instance of BooleanSearch.
   */
  setAutoForm() {
    const e = `       
        <form id="${this.id}_searchForm">
            <input id="${this.id}_searchbox" type="text" placeholder="Type boolean search expression here..." aria-label="Type boolean search expression here..." style="width: 500px; padding: 5px; border: 1px solid #ccc; border-radius: 4px; " />
            <button id="${this.id}_button" type="button" aria-label="Do Search">
            Search
            </button>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
            <label>
            Case Sensitive <input type="checkbox" id="${this.id}_checkbox" > 
            </label>
            <br>
            <small> <b> &nbsp;&nbsp;&nbsp; <a href="https://www.npmjs.com/package/boolean-search-filter"> boolean search supported</a>: </b> eg. (John OR "Jane Smith") AND NOT journal </small>
        </form>
        <div id="${this.id}_error" style="color: red; font-weight: bold"></div>
        <div id="${this.id}_answer"></div>
        `;
    return document.getElementById(this.id).innerHTML = e, this;
  }
  /*
      <input size="40"  id="wordInput" placeholder="Type words here..."></input>
      <button id="button" onclick="highlightWords()">Search</button>
      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      <label>
        Case Sensitive <input type="checkbox" id="caseSensitiveCheckbox" onclick="toggleCaseSensitive()"> 
      </label>
  
  */
  /**
   * Sets a custom search form in the HTML element with the specified ID.
   * @param {string} formString - The HTML string for the custom search form.
   * @returns {this} The current instance of BooleanSearch.
   */
  setForm(e) {
    return document.getElementById(this.id).innerHTML = e, this;
  }
  /**
   * Sets the ID of the HTML element where the search form will be inserted.
   * @param {string} id - The ID of the HTML element.
   * @returns {this} The current instance of BooleanSearch.
   */
  setId(e) {
    return this.id = e, this;
  }
  /**
   * Sets the CSS selector for the elements to be searched.
   * @param {string} elementsCssSelector - The CSS selector for the elements.
   * @returns {this} The current instance of BooleanSearch.
   */
  setElementsCssSelector(e) {
    return this.elementsCssSelectorForItems = e, this;
  }
  /**
   * Sets the CSS selector for the section elements to be searched.
   * 
   * If this method is called then we have multiple lists, one per section, where 
   * sections are selected by the `sectionElementsCssSelector`, and elements within 
   * the section with the `elementsCssSelector`. When this method is not called the 
   * library only uses the `elementsCssSelector` for a single list of elements 
   * without any sections.
   * 
   * @param {string} elementsCssSelector - The CSS selector for the section elements.
   * @returns {this} The current instance of BooleanSearch.
   */
  setSectionElementsCssSelector(e) {
    return this.elementsCssSelectorForSectionItems = e, this;
  }
  /**
   * Sets a callback function for filtering and marking elements on the HTML page.
   * @param {(fn: BooleanSearch.filterAndMarkElementsFunc) => boolean} callback - The callback function.
   * @returns {this} The current instance of BooleanSearch.
   */
  setHtmlPageSpecificFilterAndMarkCallback(e) {
    return this.htmlPageSpecificFilterAndMarkCallback = e, this;
  }
  /**
   * Enables or disables highlighting of matched elements.
   * @param {boolean} active - Whether highlighting should be active.
   * @returns {this} The current instance of BooleanSearch.
   */
  setHighlighting(e) {
    return this.highlightingActive = e, this;
  }
  toggleCaseSensitive() {
    console.log("toggleCaseSensitive"), this.caseSensitive = !this.caseSensitive;
  }
  /**
   * Applies the search functionality to the HTML page.
   */
  apply() {
    this.htmlPageSpecificFilterAndMarkCallback === null && (this.elementsCssSelectorForSectionItems === null ? this.htmlPageSpecificFilterAndMarkCallback = this.elementsPageFilterAndMarkCallback : this.htmlPageSpecificFilterAndMarkCallback = this.sectionedElementsPageFilterAndMarkCallback);
    let e = this;
    document.addEventListener("DOMContentLoaded", function() {
      const t = document.getElementById(`${e.id}_button`), s = document.getElementById(`${e.id}_searchbox`), l = document.getElementById(`${e.id}_checkbox`), i = document.getElementById(`${e.id}_searchForm`), c = document.getElementById(`${e.id}_answer`), r = document.getElementById(`${e.id}_error`);
      t && t.addEventListener("click", function() {
        if (s) {
          const n = s.value;
          try {
            c.textContent = "", r.textContent = "", e.searchFilter(n) || (c.textContent = "No matches");
          } catch {
            r.textContent = "Error in boolean search term", e.searchFilter("fsdjfkjaskfjksdjfksdjflksdjlka");
          }
        }
      }), s && t && s.addEventListener("keyup", function(n) {
        n.key === "Enter" && (n.preventDefault(), t.click(), s.blur(), s.focus());
      }), l && t && l.addEventListener("click", function() {
        e.toggleCaseSensitive(), t.click();
      }), i && i.addEventListener("submit", function(n) {
        n.preventDefault();
      });
    });
  }
  /**
   * Filters and marks elements based on the provided boolean expression.
   * @param {string} booleanExpr - The boolean expression to filter elements.
   * @returns {boolean} Whether any elements matched the boolean expression.
   */
  searchFilter(e) {
    const t = new u(e);
    let s = (i) => this.filterAndMarkElementsMatchingBooleanExpression(i, t);
    return this.htmlPageSpecificFilterAndMarkCallback(s);
  }
  /**
   * Filters and marks elements on the page based on the provided callback function.
   * @param {BooleanSearch.filterAndMarkElementsFunc} filterAndMarkElements - The callback function to filter and mark elements.
   * @returns {boolean} Whether any elements matched the boolean expression.
   */
  elementsPageFilterAndMarkCallback(e) {
    const t = document.querySelectorAll(this.elementsCssSelectorForItems);
    return e(t);
  }
  /**
   * Filters and marks sectioned elements on the page based on the provided callback function.
   * @param {BooleanSearch.filterAndMarkElementsFunc} filterAndMarkElements - The callback function to filter and mark elements.
   * @returns {boolean} Whether any elements matched the boolean expression.
   */
  sectionedElementsPageFilterAndMarkCallback(e) {
    let t = !1;
    return document.querySelectorAll(this.elementsCssSelectorForSectionItems).forEach((l, i) => {
      let c = !1, r = l.tagName, n = l.nextElementSibling;
      for (; n && n.tagName !== r; ) {
        const h = n.querySelectorAll(this.elementsCssSelectorForItems);
        e(h) && (c = !0), n = n.nextElementSibling;
      }
      c ? (l.style.display = "", t = !0) : l.style.display = "none";
    }), t;
  }
  /**
   * Filters and marks elements that match the provided boolean expression.
   * @param {NodeListOf<HTMLElement>} elements - The elements to filter and mark.
   * @param {BooleanExpression} booleanExpr - The boolean expression to match elements against.
   * @returns {boolean} Whether any elements matched the boolean expression.
   */
  filterAndMarkElementsMatchingBooleanExpression(e, t) {
    let s = t.getWords(), l = !1;
    return e.forEach((i, c) => {
      let r = !1;
      if (i.textContent && (r = t.match(i.textContent, this.caseSensitive)), r ? (l = !0, i.style.display = "") : i.style.display = "none", this.highlightingActive && r && s) {
        f(i);
        for (const n of s)
          b(i, n, this.caseSensitive);
      }
    }), l;
  }
}
export {
  y as BooleanSearch
};
//# sourceMappingURL=BooleanSearch.es.js.map
